---
title: NodeList
slug: Web/API/NodeList
tags:
  - API
  - DOM
  - Interface
  - NodeList
---
<div>{{APIRef("DOM")}}</div>

<p><span class="seoSummary"><strong><code>NodeList</code></strong> objects are collections of <a href="/en-US/docs/Web/API/Node">nodes</a>, usually returned by properties such as {{domxref("Node.childNodes")}} and methods such as {{domxref("document.querySelectorAll()")}}.</span></p>

<div class="note">
<p>Although <code>NodeList</code> is not an <code>Array</code>, it is possible to iterate over it with <code>forEach()</code>. It can also be converted to a real <code>Array</code> using {{jsxref("Array.from()")}}.</p>

<p>However, some older browsers have not implemented <code>NodeList.forEach()</code> nor <code>Array.from()</code>. This can be circumvented by using {{jsxref("Array.forEach()", "Array.prototype.forEach()")}} — see this document's <a href="#Example">Example</a>.</p>
</div>

<h2 id="Live_vs._Static_NodeLists">Live vs. Static NodeLists</h2>

<p>Although they are both considered <code>NodeList</code>s, there are 2 varieties of NodeList: <em>live</em> and <em>static</em>.</p>

<h3 id="Live_NodeLists">Live NodeLists</h3>

<p>In some cases, the <code>NodeList</code> is <em>live</em>, which means that changes in the DOM automatically update the collection.</p>

<p>For example, {{domxref("Node.childNodes")}} is live:</p>

<pre class="brush: js notranslate">const parent = document.getElementById('parent');
let child_nodes = parent.childNodes;
console.log(child_nodes.length); // let's assume "2"
parent.appendChild(document.createElement('div'));
console.log(child_nodes.length); // outputs "3"
</pre>

<h3 id="Static_NodeLists">Static NodeLists</h3>

<p>In other cases, the <code>NodeList</code> is <em>static, </em>where any changes in the DOM does not affect the content of the collection. The ubiquitous {{domxref("document.querySelectorAll()")}} method returns a <em>static</em> <code>NodeList</code>.</p>

<p>It's good to keep this distinction in mind when you choose how to iterate over the items in the <code>NodeList</code>, and whether you should cache the list's <code>length</code>.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("NodeList.length")}}</dt>
 <dd>The number of nodes in the <code>NodeList</code>.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("NodeList.item()")}}</dt>
 <dd>Returns an item in the list by its index, or <code>null</code> if the index is out-of-bounds.</dd>
 <dd>An alternative to accessing <code>nodeList[<var>i</var>]</code> (which instead returns  <code>undefined</code> when <code><var>i</var></code> is out-of-bounds). This is mostly useful for non-JavaScript DOM implementations.</dd>
 <dt>{{domxref("NodeList.entries()")}}</dt>
 <dd>Returns an {{jsxref("Iteration_protocols","iterator")}}, allowing code to go through all key/value pairs contained in the collection. (In this case, the keys are numbers starting from <code>0</code> and the values are nodes.)</dd>
 <dt>{{domxref("NodeList.forEach()")}}</dt>
 <dd>Executes a provided function once per <code>NodeList</code> element, passing the element as an argument to the function.</dd>
 <dt>{{domxref("NodeList.keys()")}}</dt>
 <dd>Returns an {{jsxref("Iteration_protocols", "iterator")}}, allowing code to go through all the keys of the key/value pairs contained in the collection. (In this case, the keys are numbers starting from <code>0</code>.)</dd>
 <dt>{{domxref("NodeList.values()")}}</dt>
 <dd>Returns an {{jsxref("Iteration_protocols", "iterator")}} allowing code to go through all values (nodes) of the key/value pairs contained in the collection.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>It's possible to loop over the items in a <code>NodeList</code> using a <a href="/en-US/docs/Web/JavaScript/Reference/Statements/for">for</a> loop:</p>

<pre class="brush: js notranslate">for (let i = 0; i &lt; myNodeList.length; i++) {
  let item = myNodeList[i];
}
</pre>

<p><strong>Don't use <code><a href="/en-US/docs/JavaScript/Reference/Statements/for...in" title="JavaScript/ Reference/Statements/for...in">for...in</a></code> to enumerate the items in <code>NodeList</code>s</strong>, since they will <em>also</em> enumerate its <code>length</code> and <code>item</code> properties and cause errors if your script assumes it only has to deal with {{domxref("element")}} objects. Also, <code>for..in</code> is not guaranteed to visit the properties in any particular order.</p>

<p><code><a href="/en-US/docs/JavaScript/Reference/Statements/for...of">for...of</a></code> loops <strong>will</strong> loop over <code>NodeList</code> objects correctly:</p>

<pre class="brush: js notranslate">const list = document.querySelectorAll('input[type=checkbox]');
for (let checkbox of list) {
  checkbox.checked = true;
}</pre>

<p>Recent browsers also support iterator methods ({{domxref("NodeList.forEach()", "forEach()")}}) as well as {{domxref("NodeList.entries()", "entries()")}}, {{domxref("NodeList.values()", "values()")}}, and {{domxref("NodeList.keys()", "keys()")}}.</p>

<p>There is also an Internet Explorer-compatible way to use {{jsxref("Array.forEach()", "Array.prototype.forEach")}} for iteration:</p>

<pre class="brush: js notranslate">const list = document.querySelectorAll('input[type=checkbox]');
Array.prototype.forEach.call(list, function (checkbox) {
  checkbox.checked = true;
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#interface-nodelist', 'NodeList')}}</td>
   <td>{{ Spec2('DOM WHATWG') }}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('DOM3 Core', 'core.html#ID-536297177', 'NodeList')}}</td>
   <td>{{ Spec2('DOM3 Core') }}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('DOM2 Core', 'core.html#ID-536297177', 'NodeList')}}</td>
   <td>{{ Spec2('DOM2 Core') }}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('DOM1', 'level-one-core.html#ID-536297177', 'NodeList')}}</td>
   <td>{{ Spec2('DOM1') }}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.NodeList")}}</p>
